Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1362151 - [libgfchangelog]: If changelogs are not available for the requested time range, no proper error message
Summary: [libgfchangelog]: If changelogs are not available for the requested time rang...
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: GlusterFS
Classification: Community
Component: changelog
Version: mainline
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kotresh HR
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: 1364422 1365877 1365879
TreeView+ depends on / blocked
 
Reported: 2016-08-01 12:01 UTC by Kotresh HR
Modified: 2017-03-08 09:32 UTC (History)
2 users (show)

Fixed In Version: v3.10.0
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1364422 1365877 (view as bug list)
Environment:
Last Closed: 2017-03-08 09:32:28 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:


Attachments (Terms of Use)

Comment 1 Vijay Bellur 2016-08-01 12:06:36 UTC
REVIEW: http://review.gluster.org/15064 (features/libgfchangelog: Log failure in gf_histroy_changelog) posted (#1) for review on master by Kotresh HR (khiremat@redhat.com)

Comment 2 Kotresh HR 2016-08-05 09:23:57 UTC
NOTE: The steps to reproduce mentioned in #Description is incorrect hence restating the problem description and steps to reproduce.

Description of problem:

 If changelogs are not available for the requested time range, no proper error message is displayed. It just fails. If start time is less than min changelog available time, then history changelog fails with -1 as any failure and no error message is printed. Distinguishing this error will be helpful for 
the consumers to act upon it.

For example, geo-replication upon receiving this error would fallback to
xsync. 

Version-Release number of selected component (if applicable):
mainline

How reproducible:
Always

Steps to Reproduce: (For simplicity consider plain distribute setup)
This is not simple to reproduce. It might hit during replace brick scencarios.
1. Setup geo-rep between master and slave
2. Before geo-rep syncs all data from master to slave, replace the brick from
   master and write new data on master.
3. Now the replaced brick's min changelog available is much later than the
   stime (sync time) corresponding to this brick.
4. When geo-rep is started after replace brick, it would hit above case.


Actual results:
When start time is less than min available changelog, histor fails with -1 and error is not logged.

Expected results:
It should distinguish the above error, log it and fail.

Comment 3 Vijay Bellur 2016-08-05 11:11:53 UTC
REVIEW: http://review.gluster.org/15064 (features/libgfchangelog: Log failure in gf_histroy_changelog) posted (#2) for review on master by Kotresh HR (khiremat@redhat.com)

Comment 4 Vijay Bellur 2016-08-09 07:27:16 UTC
COMMIT: http://review.gluster.org/15064 committed in master by Aravinda VK (avishwan@redhat.com) 
------
commit 949472d7561d3bfd67d8204e433a25dbc8a596cc
Author: Kotresh HR <khiremat@redhat.com>
Date:   Mon Aug 1 16:59:33 2016 +0530

    features/libgfchangelog: Log failure in gf_histroy_changelog
    
    Add error logs if gf_history_changelog fails. If requested
    changelog range is not available, log the error and exit
    instead of continuing the loop and exiting in readdir
    without logging. Also fixed the duplicate MSGID number in
    'changelog-lib-messages.h'
    
    Change-Id: Icd71b89ae23b48a71380657ba5649029c32fabfd
    BUG: 1362151
    Signed-off-by: Kotresh HR <khiremat@redhat.com>
    Reviewed-on: http://review.gluster.org/15064
    Smoke: Gluster Build System <jenkins@build.gluster.org>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.org>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    Reviewed-by: Aravinda VK <avishwan@redhat.com>


Note You need to log in before you can comment on or make changes to this bug.